//---------------------------------------------------------------------------

#ifndef Zvezda_ClH
#define Zvezda_ClH
#include "Disp.h"
#include "Vector.h"
#include "Matrix.h"
Display * disp;
class Zvezda
{
  Vector Ver[6],Norm[1],point;
  int Gran[1][6];
  public:
    Zvezda()
    {
       Ver[0]=Vector(0,0,0);
       Ver[1]=Vector(2,0,0);
       Ver[2]=Vector(2,1,0);
       Ver[3]=Vector(1,1,0);
       Ver[4]=Vector(1,2,0);
       Ver[5]=Vector(0,2,0);
       Gran[0][0]=0;
       Gran[0][1]=1;
       Gran[0][2]=2;
       Gran[0][3]=3;
       Gran[0][4]=4;
       Gran[0][5]=5;
       Norm[0]=Vector(0,0,1);
       point=Vector(0.5,0.5,0);
    }
    void Transform(Matrix&M)
    {
      for(int i=0;i<6;i++)
      {
         Ver[i]=M*Ver[i];
      }
      point=M*point;
      Matrix M1=M;
      M1.Invert();
      M1.Transpose();
      Norm[0]=M1*Norm[0];
    }
    void Show()
    {
        disp->MoveTo(Ver[Gran[0][0]].x,Ver[Gran[0][0]].y);
        for(int i=0;i<6;i++)
        {
          disp->LineTo(Ver[Gran[0][i]].x,Ver[Gran[0][i]].y);
        }
        disp->LineTo(Ver[Gran[0][0]].x,Ver[Gran[0][0]].y);
        disp->MoveTo(point.x,point.y);
        disp->LineTo(Norm[0].x+point.x,Norm[0].y+point.y);
    }
};
//---------------------------------------------------------------------------
#endif
