//---------------------------------------------------------------------------

#ifndef Zvezda_ClH
#define Zvezda_ClH
#include "Disp.h"
#include "Vector.h"
#include "Matrix.h"
Display * disp;
class Zvezda
{
  Vector Ver[5],Norm[1],point;
  int Gran[1][5];
  public:
    Zvezda()
    {
       int f=0,r=1;
       const int df=72;
       for(int i=0;i<5;i++)
       {
          Ver[i].x=-r*sin(f*3.14/180);
          Ver[i].y=r*cos(f*3.14/180);
          Ver[i].z=0;
          f=f+df;
       }
       int i=0;
       int k=0;
       for(int j=0;j<5;j++)
       {
          k=i+2;
          if(k>4)
          {
            k=k-5;
          }
          Gran[0][j]=k;
          i=k;
       }
       Norm[0]=Vector(0,0,1);
       point=Vector(0,0,0);
    }
    void Transform(Matrix&M)
    {
      for(int i=0;i<5;i++)
      {
         Ver[i]=M*Ver[i];
      }
      point=M*point;
      Matrix M1=M;
      M1.Invert();
      M1.Transpose();
      Norm[0]=M1*Norm[0];
    }
    void Show()
    {
        disp->MoveTo(Ver[Gran[0][0]].x,Ver[Gran[0][0]].y);
        for(int i=0;i<5;i++)
        {
          disp->LineTo(Ver[Gran[0][i]].x,Ver[Gran[0][i]].y);
        }
        disp->LineTo(Ver[Gran[0][0]].x,Ver[Gran[0][0]].y);
        disp->MoveTo(point.x,point.y);
        disp->LineTo(Norm[0].x+point.x,Norm[0].y+point.y);
    }
};
//---------------------------------------------------------------------------
#endif
