//---------------------------------------------------------------------------

#ifndef KubH
#define KubH
#include "Disp.h"
#include "Vector.h"
#include "Matrix.h"
Display * disp;
class Kub
{
  Vector Loc,e1,e2,e3,n[6],p[6];
  public:
  Kub(Vector a_Loc,
      Vector a_e1,
      Vector a_e2,
      Vector a_e3)
      {
           Loc=a_Loc;
           e1=a_e1;
           e2=a_e2;
           e3=a_e3;
           n[0]=e1^e3;
           n[0]=n[0]/!n[0];
           n[1]=e2^e3;
           n[1]=n[1]/!n[1];
           n[2]=e3^e1;
           n[2]=n[2]/!n[2];
           n[3]=e3^e2;
           n[3]=n[3]/!n[3];
           n[4]=e1^e2;
           n[4]=n[4]/!n[4];
           n[5]=e2^e1;
           n[5]=n[5]/!n[5];
           p[0]=Vector((2*e1.x+2*e3.x)/4,(2*e1.y+2*e3.y)/4,(2*e1.z+2*e3.z)/4);
           p[1]=Vector((2*e1.x+e2.x+e3.x)/2,(4*e1.y+2*e2.y+2*e3.y)/4,(4*e1.z+2*e2.z+2*e3.z)/4);
           p[2]=Vector((2*e1.x+4*e2.x+2*e3.x)/4,(2*e1.y+4*e2.y+2*e3.y)/4,(2*e1.z+4*e2.z+2*e3.z)/4);
           p[3]=Vector((2*e2.x+2*e3.x)/4,(2*e2.y+2*e3.y)/4,(2*e2.z+2*e3.z)/4);
           p[4]=Vector((2*e1.x+2*e2.x+4*e3.x)/4,(2*e1.y+2*e2.y+4*e3.y)/4,(2*e1.z+2*e2.z+4*e3.z)/4);
           p[5]=Vector((2*e1.x+2*e2.x)/4,(2*e1.y+2*e2.y)/4,(2*e1.z+2*e2.z)/4);
           for(int i=0;i<6;i++)
           {
              p[i]=p[i]+Loc;
           }
           }
      void Show()
      {
      disp->MoveTo(Loc.x,Loc.y);
      disp->LineTo(e1.x,e1.y);
      disp->MoveTo(Loc.x,Loc.y);
      disp->LineTo(e2.x,e2.y);
      disp->MoveTo(Loc.x,Loc.y);
      disp->LineTo(e3.x,e3.y);
      disp->MoveTo(e1.x,e1.y);
      disp->LineTo(e1.x+e2.x,e1.y+e2.y);
      disp->LineTo(e2.x,e2.y);
      disp->LineTo(e2.x+e3.x,e2.y+e3.y);
      disp->LineTo(Loc.x+e3.x,Loc.y+e3.y);
      disp->LineTo(e1.x+e3.x,e1.y+e3.y);
      disp->LineTo(e1.x+e2.x+e3.x,e1.y+e2.y+e3.y);
      disp->LineTo(e2.x+e3.x,e2.y+e3.y);
      disp->MoveTo(e1.x+e2.x+e3.x,e1.y+e2.y+e3.y);
      disp->LineTo(e1.x+e2.x,e1.y+e2.y);
      disp->MoveTo(e1.x,e1.y);
      disp->LineTo(e1.x+e3.x,e1.y+e3.y);
      for(int i=0;i<6;i++)
      {
        disp->MoveTo(p[i].x,p[i].y);
        disp->LineTo(n[i].x+p[i].x,n[i].y+p[i].y);
      }
   }
   void Transform(Matrix & M)
   {
      Loc=M*Loc;
      e1=M*e1;
      e2=M*e2;
      e3=M*e3;
      for(int i=0;i<6;i++)
      {
         p[i]=M*p[i];
      }
      Matrix M1=M;
      M1.Invert();
      M1.Transpose();
      for(int i=0;i<6;i++)
      {
         n[i]=M1*n[i];
      }
   }
};
//---------------------------------------------------------------------------
#endif
