//---------------------------------------------------------------------------

#ifndef Kub2H
#define Kub2H
#include "Disp.h"
#include "Vector.h"
#include "Matrix.h"
Display * disp;
class Kub
{
  Vector Ver[8],Norm[6],points[6];
  int Gran[6][4];
  public:
  Kub()
        {
          Ver[0]=Vector(0,0,0);
          Ver[1]=Vector(1,0,0);
          Ver[2]=Vector(1,1,0);
          Ver[3]=Vector(0,1,0);
          Ver[4]=Vector(0,0,1);
          Ver[5]=Vector(1,0,1);
          Ver[6]=Vector(1,1,1);
          Ver[7]=Vector(0,1,1);

          Norm[0]=(Ver[1]-Ver[0])^(Ver[4]-Ver[0]);
          Norm[1]=(Ver[2]-Ver[1])^(Ver[5]-Ver[1]);
          Norm[2]=(Ver[7]-Ver[3])^(Ver[2]-Ver[3]);
          Norm[3]=(Ver[4]-Ver[0])^(Ver[3]-Ver[0]);
          Norm[4]=(Ver[5]-Ver[4])^(Ver[7]-Ver[4]);
          Norm[5]=(Ver[3]-Ver[0])^(Ver[1]-Ver[0]);
          for(int i=0;i<6;i++)
          {
             Norm[i]=Norm[i]/!Norm[i];
          }
          for(int i=0;i<4;i++)
          {
             Gran[4][i]=i+4;
          }
          Gran[5][0]=0;
          Gran[5][1]=3;
          Gran[5][2]=2;
          Gran[5][3]=1;
          Gran[0][0]=0;
          Gran[0][1]=1;
          Gran[0][2]=5;
          Gran[0][3]=4;
          Gran[1][0]=1;
          Gran[1][1]=5;
          Gran[1][2]=6;
          Gran[1][3]=2;
          Gran[2][0]=2;
          Gran[2][1]=3;
          Gran[2][2]=7;
          Gran[2][3]=6;
          Gran[3][0]=3;
          Gran[3][1]=0;
          Gran[3][2]=4;
          Gran[3][3]=7;
          Vector s=Vector(0,0,0);
          for(int j=0;j<6;j++)
          {
            s=(0, 0, 0);
            for(int i=0;i<4;i++)
            {
              s=s+Ver[Gran[j][i]];
            }
            s=s/4;
            points[j]=s;
          }
        }
      void Show()
   {

      for(int j=0;j<6;j++)
      {

         if(Norm[j].z>0)
         {
            disp->MoveTo(Ver[Gran[j][0]].x,Ver[Gran[j][0]].y);
            for(int i=1;i<4;i++)
            {
              disp->LineTo(Ver[Gran[j][i]].x,Ver[Gran[j][i]].y);
            }
            disp->LineTo(Ver[Gran[j][0]].x,Ver[Gran[j][0]].y);
            disp->MoveTo(points[j].x,points[j].y);
            disp->LineTo(Norm[j].x+points[j].x,Norm[j].y+points[j].y);
         }//if
      }

   }
   void Transform(Matrix & M)
   {

      for(int i=0;i<6;i++)
      {
         points[i]=M*points[i];
      }
      for(int i=0;i<8;i++)
      {
         Ver[i]=M*Ver[i];
      }
      Matrix M1=M;
      M1.Invert();
      M1.Transpose();
      for(int i=0;i<6;i++)
      {
         Norm[i]=M1*Norm[i];
      }
   }
};
//---------------------------------------------------------------------------
#endif
