//---------------------------------------------------------------------------
#ifndef __MATRIX_H__
#define __MATRIX_H__
//---------------------------------------------------------------------------
#include "vector.h"
//---------------------------------------------------------------------------
class Matrix {
  public:
    double x[ 4 ][ 4 ];
    Matrix () {};
    Matrix ( double );
    Matrix& operator += ( const Matrix& );
    Matrix& operator -= ( const Matrix& );
    Matrix& operator *= ( const Matrix& );
    Matrix& operator *= ( double );
    Matrix& operator /= ( double );
    void Invert ();
    void Transpose ();
    friend const Matrix operator + ( const Matrix& m1, const Matrix& m2) {
      return Matrix( m1 ) += m2;
      }
    friend const Matrix operator - ( const Matrix& m1, const Matrix& m2) {
      return Matrix( m1 ) -= m2;
      }
    friend const Matrix operator * ( const Matrix& m1, const Matrix& m2) {
      return Matrix( m1 ) *= m2;
      }
    friend const Matrix operator * ( const Matrix& m, double d ) {
      return Matrix( m ) *= d;
      }
    friend const Vector operator * ( const Matrix&, const Vector& );
  };

  Matrix Translate ( const Vector& );
  Matrix Scale ( const Vector& );
  Matrix RotateX ( double );
  Matrix RotateY ( double );
  Matrix RotateZ ( double );
  Matrix Rotate ( const Vector&,double );
  Matrix MirrorX ();
  Matrix MirrorY ();
  Matrix MirrorZ ();
  void Print( const Matrix& );
  Matrix Akson();
  Matrix Persp( double );

#endif